### Hierarchy

- OpenVidu

## Index

### Constructors

- constructor

### Properties

- activeSessions

### Methods

- createSession
- deleteRecording
- fetch
- getRecording
- listRecordings
- startRecording
- stopRecording

## Constructors

### constructor

- new OpenVidu(urlOpenViduServer: string, secret: string): OpenVidu

- - Defined in OpenVidu.ts:80

  #### Parameters

  - ##### urlOpenViduServer: string

    Public accessible IP where your instance of OpenVidu Server is up an running

  - ##### secret: string

    Secret used on OpenVidu Server initialization

  #### Returns OpenVidu

## Properties

### activeSessions

activeSessions: Session[] = []

- Defined in OpenVidu.ts:80

Array of active sessions. This value will remain unchanged since the last time method OpenVidu.fetch was called. Exceptions to this rule are:

- Calling Session.fetch updates that specific Session status
- Calling Session.close automatically removes the Session from the list of active Sessions
- Calling Session.forceDisconnect automatically updates the inner affected connections for that specific Session
- Calling Session.forceUnpublish also automatically updates the inner affected connections for that specific Session
- Calling OpenVidu.startRecording and OpenVidu.stopRecording automatically updates the recording status of the Session (Session.recording)

To get the array of active sessions with their current actual value, you must call OpenVidu.fetch before consulting property activeSessions

## Methods

### createSession

- createSession(properties?: SessionProperties): Promise<Session>

- - Defined in OpenVidu.ts:97

  Creates an OpenVidu session. You can call Session.getSessionId inside the resolved promise to retrieve the `sessionId`

  #### Parameters

  - ##### Optional properties: SessionProperties

  #### Returns Promise<Session>

  A Promise that is resolved to the Session if success and rejected with an Error object if not.

### deleteRecording

- deleteRecording(recordingId: string): Promise<Error>

- - Defined in OpenVidu.ts:354

  Deletes a Recording. The recording must have status `stopped` or `available`

  #### Parameters

  - ##### recordingId: string

  #### Returns Promise<Error>

  A Promise that is resolved if the Recording was successfully deleted and rejected with an Error object if not. This Error object has as `message` property with the following values:

  - `404`: no recording exists for the passed `recordingId`
  - `409`: the recording has `started` status. Stop it before deletion

### fetch

- fetch(): Promise<boolean>

- - Defined in OpenVidu.ts:398

  Updates every property of every active Session with the current status they have in OpenVidu Server. After calling this method you can access the updated array of active sessions in activeSessions

  #### Returns Promise<boolean>

  A promise resolved to true if any Session status has changed with respect to the server, or to false if not. This applies to any property or sub-property of any of the sessions locally stored in OpenVidu Node Client

### getRecording

- getRecording(recordingId: string): Promise<Recording>

- - Defined in OpenVidu.ts:262

  Gets an existing Recording

  #### Parameters

  - ##### recordingId: string

    The `id` property of the Recording you want to retrieve

  #### Returns Promise<Recording>

  A Promise that is resolved to the Recording if it successfully stopped and rejected with an Error object if not. This Error object has as `message` property with the following values:

  - `404`: no recording exists for the passed `recordingId`

### listRecordings

- listRecordings(): Promise<Recording[]>

- - Defined in OpenVidu.ts:304

  Lists all existing recordings

  #### Returns Promise<Recording[]>

  A Promise that is resolved to an array with all existing recordings

### startRecording

- startRecording(sessionId: string): Promise<Recording>
- startRecording(sessionId: string, name: string): Promise<Recording>
- startRecording(sessionId: string, properties: RecordingProperties): Promise<Recording>

- - Defined in OpenVidu.ts:111

  Starts the recording of a Session

  #### Parameters

  - ##### sessionId: string

    The `sessionId` of the Session you want to start recording

  #### Returns Promise<Recording>

  A Promise that is resolved to the Recording if it successfully started (the recording can be stopped with guarantees) and rejected with an Error object if not. This Error object has as `message` property with the following values:

  - `404`: no session exists for the passed `sessionId`
  - `400`: the session has no connected participants
  - `409`: the session is not configured for using MediaMode.ROUTED or it is already being recorded
  - `501`: OpenVidu Server recording module is disabled (`openvidu.recording` property set to `false`)
- - Defined in OpenVidu.ts:112

  Starts the recording of a Session

  #### Parameters

  - ##### sessionId: string

    The `sessionId` of the Session you want to start recording

  - ##### name: string

    The name you want to give to the video file. You can access this same value in your clients on recording events (`recordingStarted`, `recordingStopped`) WARNING: this parameter follows an overwriting policy. If you name two recordings the same, the newest MP4 file will overwrite the oldest one

  #### Returns Promise<Recording>

  A Promise that is resolved to the Recording if it successfully started (the recording can be stopped with guarantees) and rejected with an Error object if not. This Error object has as `message` property with the following values:

  - `404`: no session exists for the passed `sessionId`
  - `400`: the session has no connected participants
  - `409`: the session is not configured for using MediaMode.ROUTED or it is already being recorded
  - `501`: OpenVidu Server recording module is disabled (`openvidu.recording` property set to `false`)
- - Defined in OpenVidu.ts:113

  Starts the recording of a Session

  #### Parameters

  - ##### sessionId: string

    The `sessionId` of the Session you want to start recording

  - ##### properties: RecordingProperties

  #### Returns Promise<Recording>

  A Promise that is resolved to the Recording if it successfully started (the recording can be stopped with guarantees) and rejected with an Error object if not. This Error object has as `message` property with the following values:

  - `404`: no session exists for the passed `sessionId`
  - `400`: the session has no connected participants
  - `409`: the session is not configured for using MediaMode.ROUTED or it is already being recorded
  - `501`: OpenVidu Server recording module is disabled (`openvidu.recording` property set to `false`)

### stopRecording

- stopRecording(recordingId: string): Promise<Recording>

- - Defined in OpenVidu.ts:210

  Stops the recording of a Session

  #### Parameters

  - ##### recordingId: string

    The `id` property of the Recording you want to stop

  #### Returns Promise<Recording>

  A Promise that is resolved to the Recording if it successfully stopped and rejected with an Error object if not. This Error object has as `message` property with the following values:

  - `404`: no recording exists for the passed `recordingId`
  - `406`: recording has `starting` status. Wait until `started` status before stopping the recording

Generated using TypeDoc